require "./lib/sylfy.rb"
require "test/unit"

class TestReactionKey < Test::Unit::TestCase
    def test_reactionkey
        a = ['MEFKEPWMEQBLKI-AIRLBKTGSA-O', 'QAIPRVGONGVQAS-DUXPYHPUSA-M;2.0']
        b = ['ZJUKTBDSGOFHSH-WFMPWKQPSA-N', 'KSEBMYQBYZTDHS-HWKANZROSA-M', 'GPRLSGONYQIRFK-UHFFFAOYSA-N']
        
        c = ['MEFKEPWMEQBLKI-AIRLBKTGSA-O', 'QAIPRVGONGVQAS-DUXPYHPUSA-M;2.0', "VWWQXMAJTJZDQX-UYBVJOGSSA-N"]
        d = ['ZJUKTBDSGOFHSH-WFMPWKQPSA-N', 'KSEBMYQBYZTDHS-HWKANZROSA-M', 'GPRLSGONYQIRFK-UHFFFAOYSA-N', "YPZRHBJKEMOYQH-UYBVJOGSSA-N"]
        
        assert_equal(Sylfy::Utils::reactionkey(b, a, "<="), Sylfy::Utils::reactionkey(a, b, "=>"))
        assert_equal(Sylfy::Utils::reactionkey(b, a, "<=>"), Sylfy::Utils::reactionkey(a, b, "<=>"))
        assert_equal(Sylfy::Utils::reactionkey(b, a, "<?>"), Sylfy::Utils::reactionkey(a, b, "<?>"))
        
        assert_equal("#{Sylfy::Utils::reactionkey(a, b, "<=")[0..-2]}B", Sylfy::Utils::reactionkey(a, b, "=>"))
        assert_equal("#{Sylfy::Utils::reactionkey(a, b, "<=")[0..-2]}F", Sylfy::Utils::reactionkey(a, b, "<="))
        assert_equal("#{Sylfy::Utils::reactionkey(a, b, "<=")[0..-2]}R", Sylfy::Utils::reactionkey(a, b, "<=>"))
        assert_equal("#{Sylfy::Utils::reactionkey(a, b, "<=")[0..-2]}U", Sylfy::Utils::reactionkey(a, b, "<?>"))
        
        assert_equal(Sylfy::Utils::reactionkey(d, c, "<="), Sylfy::Utils::reactionkey(c, d, "=>"))
        assert_equal(Sylfy::Utils::reactionkey(d, c, "<=>"), Sylfy::Utils::reactionkey(c, d, "<=>"))
        assert_equal(Sylfy::Utils::reactionkey(d, c, "<?>"), Sylfy::Utils::reactionkey(c, d, "<?>"))
        assert_equal("#{Sylfy::Utils::reactionkey(c, d, "<=")[0..-2]}B", Sylfy::Utils::reactionkey(c, d, "=>"))
        assert_equal("#{Sylfy::Utils::reactionkey(c, d, "<=")[0..-2]}F", Sylfy::Utils::reactionkey(c, d, "<="))
        assert_equal("#{Sylfy::Utils::reactionkey(c, d, "<=")[0..-2]}R", Sylfy::Utils::reactionkey(c, d, "<=>"))
        assert_equal("#{Sylfy::Utils::reactionkey(c, d, "<=")[0..-2]}U", Sylfy::Utils::reactionkey(c, d, "<?>"))
        
        assert_not_equal(Sylfy::Utils::reactionkey(a, d, "<?>"), Sylfy::Utils::reactionkey(c, d, "<?>"))
        assert_not_equal(Sylfy::Utils::reactionkey(c, b, "<?>"), Sylfy::Utils::reactionkey(c, d, "<?>"))
        
        assert_equal(Sylfy::Utils::reactionkey(b.shuffle, a.shuffle, "=>"), Sylfy::Utils::reactionkey(b, a, "=>"))
        
        #assert_equal("RBBGYPGMOGQICO-ANDFYIIK-PRHFFSIG-AB-A-B", Sylfy::Utils::reactionkey(c, d, "=>"))
        #assert_equal("RBBGYPGMOGQICO-ANDFYIIK-PRHFFSIG-AA-A-B", Sylfy::Utils::reactionkey(a, b, "=>"))
    end
end